#!/usr/bin/perl

$LOCKDIR = "/var/spool/uucp";
$LOCKDIR = "/var/spool/lock";
$LOCKDIR = "/var/lock/uucp";

$isdn = 1;
while ($isdn) {
	unless (-c "/dev/isdn/isdn$isdn") {
		unlink("$LOCKDIR/LTMP..$$");
		print STDERR "Couldn't find any free isdn device.\n";
		exit 1;
	}
	open(LOCK, ">$LOCKDIR/LTMP..$$") || die;
	printf(LOCK "%10d", $$);
	close LOCK;
	unless (link ("$LOCKDIR/LTMP..$$", "$LOCKDIR/isdn$isdn")) {
		open(LOCK, "$LOCKDIR/isdn$isdn") || die "$!";
		$pid = <LOCK> + .0;
		close LOCK;
		unless (kill 0, $pid) {
		print STDERR "Stale lock isdn$isdn held by process $pid\n";
			unlink("$LOCKDIR/isdn$isdn");
			next;
		}
	} else {
		last if open (ISDN, "+</dev/isdn/isdn$isdn");
	}
	$isdn++;
}
unlink("$LOCKDIR/LTMP..$$");
print ISDN "AT/L\n";

$/ = "\r\n";
while (<ISDN>) {
	last if /^OK/;
	next if /^AT/;
	next if /^!/;
	next if /^#/;
	print;
}
close ISDN;
unlink("$LOCKDIR/isdn$isdn");
exit 0;
